3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
14 git_broken_path_fix
() {
25 case "$SANE_TOOL_PATH:$elem" in
26 (?
*:/bin | ?
*:/usr
/bin
)
27 path
="$path$sep$SANE_TOOL_PATH"
47 if test -n "$OPTIONS_SPEC"; then
54 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
55 parseopt_extra
="--keep-dashdash"
58 echo "$OPTIONS_SPEC" |
59 git rev-parse --parseopt $parseopt_extra -- "$@
" ||
63 dashless
=$
(basename "$0" |
sed -e 's/-/ /')
65 die
"Usage: $dashless $USAGE"
68 if [ -z "$LONG_USAGE" ]
70 LONG_USAGE
="Usage: $dashless $USAGE"
72 LONG_USAGE
="Usage: $dashless $USAGE
78 -h|
--h|
--he|
--hel|
--help)
85 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
87 GIT_REFLOG_ACTION
="$*"
88 export GIT_REFLOG_ACTION
93 : "${GIT_EDITOR:=$(git config core.editor)}"
94 : "${GIT_EDITOR:=${VISUAL:-${EDITOR}}}"
95 case "$GIT_EDITOR,$TERM" in
97 echo >&2 "No editor specified in GIT_EDITOR, core.editor, VISUAL,"
98 echo >&2 "or EDITOR. Tried to fall back to vi but terminal is dumb."
99 echo >&2 "Please set one of these variables to an appropriate"
100 echo >&2 "editor or run $0 with options that will not cause an"
101 echo >&2 "editor to be invoked (e.g., -m or -F for git-commit)."
105 eval "${GIT_EDITOR:=vi}" '"$@"'
108 is_bare_repository
() {
109 git rev-parse
--is-bare-repository
113 cdup
=$
(git rev-parse
--show-cdup)
116 # The "-P" option says to follow "physical" directory
117 # structure instead of following symbolic links. When cdup is
118 # "../", this means following the ".." entry in the current
119 # directory instead textually removing a symlink path element
120 # from the PWD shell variable. The "-P" behavior is more
121 # consistent with the C-style chdir used by most of Git.
123 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
129 require_work_tree
() {
130 test $
(git rev-parse
--is-inside-work-tree) = true ||
131 die
"fatal: $0 cannot be used without a working tree."
134 get_author_ident_from_commit
() {
137 s/'\''/'\''\\'\'\''/g
139 s/^author \([^<]*\) <[^>]*> .*$/\1/
141 s
/.
*/GIT_AUTHOR_NAME
='\''&'\''/p
144 s
/^author
[^
<]* <\
([^
>]*\
)> .
*$
/\
1/
146 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
149 s/^author [^<]* <[^>]*> \(.*\)$/\1/
151 s
/.
*/GIT_AUTHOR_DATE
='\''&'\''/p
156 encoding=$(git config i18n.commitencoding || echo UTF-8)
157 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
158 LANG=C LC_ALL=C sed -ne "$pick_author_script"
161 # Make sure we are in a valid repository of a vintage we understand,
162 # if we require to be in a git repository.
163 if test -z "$NONGIT_OK"
165 GIT_DIR=$(git rev-parse --git-dir) || exit
166 if [ -z "$SUBDIRECTORY_OK" ]
168 test -z "$(git rev-parse --show-cdup)" || {
170 echo >&2 "You need to run this command from the toplevel of the working tree."
174 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
175 echo >&2 "Unable to determine absolute path of git directory"
178 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
181 # Fix some commands on Windows
184 # Windows has its own (incompatible) sort and find